/*
 * PM - 2017
 * lab0.c
 */

#include <avr/io.h>
#include <util/delay.h>

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

#define MORSE_LUNG		150
#define MORSE_SCURT		50
#define MORSE_PAUZA		50

#define NUM_NOTE		8

#define SQUARE_ANIM		1
#define STG_PLS_ANIM	2
#define WK_PLS_ANIM		3
#define NO_PLS_ANIM		4

/*#define CS_Pin		PD6
#define DIN_Pin		PD1
#define CLK_Pin		PD0*/

int frecventa_nota[NUM_NOTE] = {
	262, 294, 330, 349, 392, 440, 494, 523
};
/*
CS -> PORTD 6, PD6 = Latch Data;
DIN -> PORTD 1, PD1
CLK -> PORTD 0, PD0 */


 
unsigned const short square_anim[7*8]={
//0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, //full screen
0xff, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0xff,  //animation 1  screen 1
0x00, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x00,  //             screen 2
0x00, 0x00, 0x3C, 0x24, 0x24, 0x3C, 0x00, 0x00,	 //			    screen 3
0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00,	 //				screen 4
0x00, 0x00, 0x3C, 0x24, 0x24, 0x3C, 0x00, 0x00,	 //				screen 5
0x00, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x00,  //             screen 6
0xff, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0xff  //animation 1  screen 7
};

unsigned const short strong_pulse[10*8]={
0x00, 0x8, 0xC, 0xCB, 0x28, 0x18, 0x8, 0x00,
0x00, 0x4, 0x6, 0xE5, 0x14, 0xC, 0x4, 0x00,
0x00, 0x2, 0x3, 0xF2, 0xA, 0x6, 0x2, 0x00,
0x00, 0x1, 0x1, 0xF9, 0x5, 0x3, 0x1, 0x00,
0x00, 0x00, 0x00, 0xFC, 0x2, 0x1, 0x00, 0x00,
0x00, 0x00, 0x80, 0x7E, 0x1, 0x00, 0x00, 0x00,
0x00, 0x80, 0xC0, 0xBF, 0x80, 0x80, 0x80, 0x00,
0x00, 0x40, 0x60, 0x5F, 0x40, 0xC0, 0x40, 0x00,
0x00, 0x20, 0x30, 0x2F, 0xA0, 0x60, 0x20, 0x00,
0x00, 0x10, 0x18, 0x97, 0x50, 0x30, 0x10, 0x00,
};

unsigned const short weak_pulse[11*8]={
0x00, 0x00, 0x8, 0xEF, 0x18, 0x8, 0x00, 0x00,
0x00, 0x00, 0x4, 0xF7, 0xC, 0x4, 0x00, 0x00,
0x00, 0x00, 0x2, 0xFB, 0x6, 0x2, 0x00, 0x00,
0x00, 0x00, 0x1, 0xFD, 0x3, 0x1, 0x00, 0x00,
0x00, 0x00, 0x0, 0xFE, 0x1, 0x0, 0x00, 0x00,
0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x80, 0xFF, 0xC0, 0x80, 0x00, 0x00,
0x00, 0x00, 0x40, 0x7F, 0xC0, 0x40, 0x00, 0x00,
0x00, 0x00, 0x20, 0xBF, 0x60, 0x20, 0x00, 0x00,
0x00, 0x00, 0x10, 0xDF, 0x30, 0x10, 0x00, 0x00
};

unsigned const short no_pulse[1*8]={
0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00
};

 
void SPI_Write_Byte(unsigned short num)
	{
		unsigned short t, Mask, Flag;
		DDRD |= (1 << PD0);
		DDRD |= (1 << PD1);
		PORTD &= ~(1 << PD0);
		Mask = 128;
		for (t=0; t<8; t++) 
			{
				Flag = num & Mask; 
				if(Flag == 0) { 
					PORTD &= ~(1 << PD1);
				} else { 
					PORTD |= (1 << PD1);
				} 
				PORTD |= (1 << PD0);
				PORTD &= ~(1 << PD0);
				Mask = Mask >> 1;
	}
}

void MAX7219_INIT() {
 
	DDRD |= (1 << PD6);

	// Set BCD decode mode
	PORTD &= ~(1 << PD6); // CS pin is pulled LOW
	SPI_Write_Byte(0x09); // Select Decode Mode register
	SPI_Write_Byte(0x00); // Select BCD mode for digits DIG0-DIG7
	PORTD |= (1 << PD6); // CS pin is pulled HIGH
	 
	// Set display brighness
	PORTD &= ~(1 << PD6); // CS pin is pulled LOW
	SPI_Write_Byte(0x0A); // Select Intensity register
	SPI_Write_Byte(0x05); // Set brightness
	PORTD |= (1 << PD6); // CS pin is pulled HIGH
	 
	// Set display refresh
	PORTD &= ~(1 << PD6); // CS pin is pulled LOW
	SPI_Write_Byte(0x0B); // Select Scan-Limit register
	SPI_Write_Byte(0x07); // Select digits DIG0-DIG3
	PORTD |= (1 << PD6); // CS pin is pulled HIGH
	 
	// Turn on the display
	PORTD &= ~(1 << PD6); // CS pin is pulled LOW
	SPI_Write_Byte(0x0C);
	SPI_Write_Byte(0x01);
	PORTD |= (1 << PD6); // CS pin is pulled HIGH
	 
	// Disable Display-Test
	PORTD &= ~(1 << PD6); // CS pin is pulled LOW
	SPI_Write_Byte(0x0F); // Select Display-Test register
	SPI_Write_Byte(0x00); // Disable Display-Test
	PORTD |= (1 << PD6); // CS pin is pulled HIGH

}


void Write_Byte(unsigned short myColumn, unsigned short myValue) {
	PORTD &= ~(1 << PD6); // select max7219.
	SPI_Write_Byte(myColumn); // send myColumn value to max7219 (digit place).
	SPI_Write_Byte(myValue); // send myValue value to max7219 (digit place).
	PORTD |= (1 << PD6); // deselect max7219.
}
 
// This is clear matrix function.
void Clear_Matrix(void) {
	unsigned short x;
	for(x=1;x<9;x++)
	{
		Write_Byte(x,0x00);
	}
}
 
void Write_Char(char myChar, int animation)
{
	unsigned short Column, Start_Byte;
	 
	// Clear the display first.
	Clear_Matrix();
	// The next line defines our byte, from which to start the array.
	Start_Byte = myChar * 8; // 65 represents the letter "A" in ASCII code.

	// We are using only columns from 2 through 7 for displaying the character.
	if (animation == SQUARE_ANIM)
		for(Column=1;Column<9;Column++)
		{
			Write_Byte(Column, square_anim[Start_Byte++]);
		}
	if (animation == STG_PLS_ANIM)
		for(Column=1;Column<9;Column++)
		{
			Write_Byte(Column, strong_pulse[Start_Byte++]);
		}
	if (animation == WK_PLS_ANIM)
		for(Column=1;Column<9;Column++)
		{
			Write_Byte(Column, weak_pulse[Start_Byte++]);
		}
	if (animation == NO_PLS_ANIM)
		for(Column=1;Column<9;Column++)
		{
			Write_Byte(Column, no_pulse[Start_Byte++]);
		}		
}

/* Genereaza o nota folosind speaker-ul. */
void speaker_reda(int nota) {
	int perioada_nota = 1000000l / frecventa_nota[nota];
	int i;

	/*
	 * Nu putem folosi variable ca argument pentru functia
	 * _delay_us(), asa ca folosim acest "workaround".
	 */
	PORTD |= (1 << PD5);
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);

	PORTD &= ~(1 << PD5);
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);
}

/* Aprinde LED-ul corespunzator notei alese. */
void led_aprinde(int nota) {
	PORTC = (1 << nota);
}

/* Stinge LED-urile. */
void led_stinge(void) {
	PORTC = 0x00;
}

/*
 * Genereaza note folosind speaker-ul. Nota generata este aleasa folosind
 * butoanele PB2 si PD6.
 */
void task3(void) {
	int apasat0 = 0;
	int apasat1 = 0;

	int nota_curenta = -1;

	/* Setez pinii PB2 si PD6 ca pini de intrare. */
	DDRB &= ~(1 << PB2);
	DDRD &= ~(1 << PD6);

	/* Activez rezistenta de pull-up pentru pinii PB2 si PD6. */
	PORTB |= (1 << PB2);
	PORTD |= (1 << PD6);

	/* Setez toti pinii portului C ca pini de iesire. */
	DDRC = 0xFF;

	/* Sting toate LED-urile*/
	PORTC = 0x00;

	/* Setez pinul PD4 ca iesire. */
	DDRD |= (1 << PD4);

	/* Opresc speaker-ul. */
	PORTD &= ~(1 << PD4);

	while (1) {
		if ((PINB & (1 << PB2)) == 0) {
			if (!apasat0) {
				if (nota_curenta < NUM_NOTE - 1)
					++nota_curenta;

				apasat0 = 1;
				_delay_ms(10);
			}
		} else {
			apasat0 = 0;
		}

		if ((PIND & (1 << PD6)) == 0) {
			if (!apasat1) {
				if (nota_curenta > -1)
					--nota_curenta;

				apasat1 = 1;
				_delay_ms(10);
			}
		} else {
			apasat1 = 0;
		}

		if (nota_curenta != -1) {
			/* Redam nota. */
			speaker_reda(nota_curenta);
		}
	}
}


int main(void) {
	/*task1();*/

	/*task3();*/


	while (1) {
		unsigned int x;

		DDRB &= ~(1 << PB2);

		/* Activez rezistenta de pull-up pentru pinul PB2. */
		PORTB |= (1 << PB2);

		/* Setez pinul PD7 ca iesire. */
		DDRD |= (1 << PD7);
		//DDRD |= (1 << PD6);


		/* Sting LED-ul. */
		PORTD &= ~(1 << PD7);

	
		if ((PINB & (1 << PB2)) == 0) {
			DDRD =0xFF;
		
			int nr_iter = 0;
			int speed1 = 180;
			int speed2 = 300;


			MAX7219_INIT(); // initialize max7219
			while (true){
				while (nr_iter < 3) {
					for(x=0;x<10;x++) // Increment with 1, from 65 until 90.
					{
						Write_Char(x, STG_PLS_ANIM);
						_delay_ms(speed1); // This is our delay, between two consecutive character.
					}
					nr_iter++;
				}
					
				for(x=0;x<5;x++) // Increment with 1, from 65 until 90.
					{
						Write_Char(x, STG_PLS_ANIM);
						_delay_ms(speed1); // This is our delay, between two consecutive character.
					}
				for(x=6;x<11;x++) // Increment with 1, from 65 until 90.
					{
						Write_Char(x, WK_PLS_ANIM);
						_delay_ms(speed2); // This is our delay, between two consecutive character.
					}
				while(nr_iter < 6) {
					for(x=0;x<11;x++) // Increment with 1, from 65 until 90.
						{
							Write_Char(x, WK_PLS_ANIM);
							_delay_ms(speed2); // This is our delay, between two consecutive character.
						}
						nr_iter++;
				}
				for(x=0;x<6;x++) // Increment with 1, from 65 until 90.
					{
						Write_Char(x, WK_PLS_ANIM);
						_delay_ms(speed2); // This is our delay, between two consecutive character.
					}
					nr_iter++;

				while(nr_iter < 100){
					Write_Char(0, NO_PLS_ANIM);
					_delay_ms(50);
					nr_iter++;
				}
				nr_iter = 0;
			}
		} 
	}
	

	return 0;
}
